#include "phonemes.h"
#include "control.h"

extern int translate_phone();

extern int LastTarget[20];
extern int Frames[MAX_FRAMES][20];
extern float f0[2],f1[2],f2[2],f3[2],bw1[2],bw2[2],bw3[2],av[2];
extern float length,s_f0,s_f1,s_f2,s_f3,s_bw1,s_bw2,s_bw3,s_av,fnp,fnz;
extern float af,ab,a1,a2,a3,a4,a5,a6,asp;
extern int   total_frame_count;
extern long Features[ALL_END+1];

extern int f0_change;

extern int Vowels[23][2][6];
extern int Nasals[5][9];

void gen_vowel(phone,segdur,prev_phone,next_phone)
int phone;
int segdur;
int prev_phone;
int next_phone;
{
  int j,features,next_feat=-1,prev_feat=-1,off,interp=0;
  float prcnt,f0_temp,f1_temp,f2_temp,f3_temp,bw1_temp,bw2_temp,bw3_temp;
  float av_temp, n_av,n_f1,n_f2,n_f3,n_bw1,n_bw2,n_bw3;
  int time_const,time_count;

  features = Features[phone];

  if (prev_phone != -1)
    prev_feat = Features[prev_phone];
  if (next_phone != -1) 
    next_feat = Features[next_phone];

  if (prev_feat != -1)
    if (prev_feat & VOWEL || prev_feat & SONOR) {
      if (prev_feat & FRICA)
        prcnt = .30;
      else 
        prcnt = .95;
        
      f1[0] -= (f1[0] - LastTarget[1]) * prcnt;
      f2[0] -= (f2[0] - LastTarget[2]) * prcnt;
      f3[0] -= (f3[0] - LastTarget[3]) * prcnt;
      bw1[0] -= (bw1[0] - LastTarget[4]) * prcnt;
      bw2[0] -= (bw2[0] - LastTarget[5]) * prcnt;
      bw3[0] -= (bw3[0] - LastTarget[6]) * prcnt;
    }
  if (next_feat != -1)
    if (next_feat & NASAL) {
      translate_phone(next_phone,&off);
      n_av = (float) Nasals[off][8];
      n_f1 = (float) Nasals[off][0];
      n_f2 = (float) Nasals[off][1];
      n_f3 = (float) Nasals[off][2];
      n_bw1 = (float) Nasals[off][3];
      n_bw2 = (float) Nasals[off][4];
      n_bw3 = (float) Nasals[off][5];
    }

  f0_temp = f0[0]; 
  f1_temp = f1[0]; 
  f2_temp = f2[0]; 
  f3_temp = f3[0]; 
  bw1_temp = bw1[0];
  bw2_temp = bw2[0];
  bw3_temp = bw3[0];
  av_temp = av[0];

  time_const = segdur;
  time_count = 0;
  for (j=0;j < segdur;j+=10) {
    Frames[total_frame_count][0] = (int)f0_temp; 
    Frames[total_frame_count][1] = (int)f1_temp; 
    Frames[total_frame_count][2] = (int)f2_temp; 
    Frames[total_frame_count][3] = (int)f3_temp; 
    Frames[total_frame_count][4] = (int)bw1_temp;
    Frames[total_frame_count][5] = (int)bw2_temp;
    Frames[total_frame_count][6] = (int)bw3_temp;
    Frames[total_frame_count][7] = (int)fnz;
    Frames[total_frame_count][8] = (int)fnp;
    Frames[total_frame_count][9] = (int)av_temp;
    Frames[total_frame_count][10] = 0;
    Frames[total_frame_count][11] = (int)asp;
    Frames[total_frame_count][12] = (int)af;
    Frames[total_frame_count][13] = (int)a1;
    Frames[total_frame_count][14] = (int)a2;
    Frames[total_frame_count][15] = (int)a3;
    Frames[total_frame_count][16] = (int)a4;
    Frames[total_frame_count][17] = (int)a5;
    Frames[total_frame_count][18] = (int)a6;
    Frames[total_frame_count][19] = (int)ab;

    if (j < (segdur/3)) 
      f0[0] += 40;
    else {
      if (f0_change != -1000)
        f0[0] -= 25;
      else 
        f0[0] -= 10;
    }

    f0_temp = f0[0];

    if (next_feat != -1)
      if ((next_feat & NASAL) && (j >= segdur-35 && j < segdur-25)) {
        f1[0] = f1_temp;
        f2[0] = f2_temp;
        f3[0] = f3_temp;
        bw1[0] = bw1_temp;
        bw2[0] = bw2_temp;
        bw3[0] = bw3_temp;
        av[0] = av_temp;

        f1[1] = n_f1;
        f2[1] = n_f2;
        f3[1] = n_f3;
        bw1[1] = n_bw1;
        bw2[1] = n_bw2;
        bw3[1] = n_bw3;
        av[1] = n_av;
        
        time_const = 10;
        time_count = 0;
        interp = 1;
      }

    if (time_const == 0)
	time_const = 4;
    if ((features & DIPTH) || interp) {
/*      f0_temp = gen_curve(f0[0],f0[1],time_const/4,time_count); */
      f1_temp = gen_curve(f1[0],f1[1],time_const/4,time_count); 
      f2_temp = gen_curve(f2[0],f2[1],time_const/4,time_count); 
      f3_temp = gen_curve(f3[0],f3[1],time_const/4,time_count); 
      bw1_temp = gen_curve(bw1[0],bw1[1],time_const/4,time_count); 
      bw2_temp = gen_curve(bw2[0],bw2[1],time_const/4,time_count); 
      bw3_temp = gen_curve(bw3[0],bw3[1],time_const/4,time_count);
      av_temp = gen_curve(av[0],av[1],time_const/4,time_count);
    }
    time_count += 10;
    total_frame_count++;
  }
  total_frame_count--;
  LastTarget[0] = Frames[total_frame_count][0];
  LastTarget[1] = Frames[total_frame_count][1];
  LastTarget[2] = Frames[total_frame_count][2];
  LastTarget[3] = Frames[total_frame_count][3];
  LastTarget[4] = Frames[total_frame_count][4];
  LastTarget[5] = Frames[total_frame_count][5];
  LastTarget[6] = Frames[total_frame_count][6];
  LastTarget[7] = Frames[total_frame_count][7];
  LastTarget[8] = Frames[total_frame_count][8];
  LastTarget[9] = Frames[total_frame_count][9];
  LastTarget[10] = Frames[total_frame_count][10];
  LastTarget[11] = Frames[total_frame_count][11];
  LastTarget[12] = Frames[total_frame_count][12];
  LastTarget[13] = Frames[total_frame_count][13];
  LastTarget[14] = Frames[total_frame_count][14];
  LastTarget[15] = Frames[total_frame_count][15];
  LastTarget[16] = Frames[total_frame_count][16];
  LastTarget[17] = Frames[total_frame_count][17];
  LastTarget[18] = Frames[total_frame_count][18];
  LastTarget[19] = Frames[total_frame_count][19];
  total_frame_count++;
}

